﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.32
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private BANano As BANano
	Private btnSend As SKButton
	Private chkRobot As SKCheckbox
	Private txtEmail As SKTextBox
	Private txtFullName As SKTextBox
	Private txtMessage As SKTextArea
	Private txtTelephone As SKTextBox
	Private Dialog As SADialog
End Sub

'check if stuff is required
Sub Required(flds As List) As Boolean
	Dim errCnt As Int = 0
	For Each strfld As String In flds
		strfld = strfld.ToLowerCase
		Dim sval As String = GetValue(strfld)
		If sval = "" Then
			errCnt = errCnt + 1
		End If
	Next
	If errCnt > 0 Then
		Return True
	Else
		Return False
	End If
End Sub

'banano get value call
Sub GetValue(elID As String) As String
	elID = elID.tolowercase
	Dim sValue As String = BANano.GetElement($"#${elID}"$).GetValue
	Return sValue
End Sub

Sub Init
	BANano.LoadLayout("#body","vContact")
End Sub

Sub btnSend_Click (event As BANanoEvent)
	Dim bRequired As Boolean = Required(Array("txtfullname","txtemail","txttelephone","txtmessage"))
	If bRequired Then
		Dialog.Initialize(Me, "RequiredFields", "RequiredFields")
		Dialog.Title = "Contact Us"
		Dialog.Content = "All the fields are required!"
		Dialog.ShowCancelButton = False
		Dialog.Show
		Return	
	End If
	
	Dim robot As Boolean = chkRobot.checked
	If robot = False Then
		Dialog.Initialize(Me, "RequiredFields", "RequiredFields")
		Dialog.Title = "Contact Us"
		Dialog.Content = "You need to confirm that you are not a robot!"
		Dialog.ShowCancelButton = False
		Dialog.Show
		Return
	End If
	'use php to send the email
	Dim sname As String = txtFullName.text
	Dim semail As String = txtEmail.text
	Dim sphone As String = txtTelephone.text
	Dim smsg As String = txtMessage.text
	Dim nmsg As String = $"Full Name: ${sname}\r\nEmail Address: ${semail}\r\nTelephone: ${sphone}\r\nMessage:\r\n${smsg}"$
	Dim se As Map = CreateMap("from":"<fromemail>", _
		"to":"<toemail>", _
		"cc":"<ccemail>", _
		"subject":"Contact Us:" & sname, _
		"msg":nmsg)
	BANano.CallInlinePHP("SendEmail", se, "contactus")
End Sub

Sub RequiredFields_OnConfirm(result As String)
	Log("Result: " & result)
End Sub


Sub BANano_CallInlinePHPResult(Success As Boolean, UniqueID As String, Result As String)
	If Success Then
		Dim resm As Map = Json2Map(Result)
		Dim response As String = resm.Get("response")
		Select Case response
			Case "failure"
				Dialog.Initialize(Me, "RequiredFields", "RequiredFields")
				Dialog.Title = "Contact Us"
				Dialog.Content = "There was an error sending the contact us details!"
				Dialog.ShowCancelButton = False
				Dialog.Show
		Case Else
				Dialog.Initialize(Me, "RequiredFields", "RequiredFields")
				Dialog.Title = "Contact Us"
				Dialog.Content = "The email was sent successfully!"
				Dialog.ShowCancelButton = False
				Dialog.Show
		End Select
	End If
End Sub


'convert a json string to a map
Sub Json2Map(strJSON As String) As Map
	Dim json As BANanoJSONParser
	Dim Map1 As Map
	Map1.Initialize
	Map1.clear
	Try
		If strJSON.length > 0 Then
			json.Initialize(strJSON)
			Map1 = json.NextObject
		End If
		Return Map1
	Catch
		Return Map1
	End Try
End Sub
